#include <bits/stdc++.h>
using namespace std;
const int mn=3*1e5+100;
vector<vector<pair<int,char > > > graf(mn);
const int mnn=1050;
int dp[mnn][mnn][3];
int dinamik[mn][3];
void dfsdp(int node,int t,int prev)
{
    for(int i=0;i<graf[t].size();i++)
    {
        if(graf[t][i].first==prev) continue;
        for(int k=0;k<3;k++) dp[node][graf[t][i].first][k]=dp[node][t][k];
        if(graf[t][i].second=='S')
        {
            dp[node][graf[t][i].first][0]++;
        }
        else if(graf[t][i].second=='I')
        {
            dp[node][graf[t][i].first][1]++;
        }
        else
        {
            dp[node][graf[t][i].first][2]++;
        }
        dfsdp(node,graf[t][i].first,t);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin>>n;
    int kolkos=0;
    pair<int,int> ss;
    bool niz=true;
    for(int i=0;i<n-1;i++)
    {
        int a,b;
        cin>>a>>b;
        if(a!=b+1 && b!=a+1) niz=false;
        char ch;
        cin>>ch;
        if(ch=='S')
        {
            kolkos++;
            ss.first=a; ss.second=b;
        }
        graf[a].push_back(make_pair(b,ch));
        graf[b].push_back(make_pair(a,ch));
    }
    if(kolkos==1)
    {
        int num=0;
        queue<int> q;
        q.push(ss.second);
        int node=q.front();
        q.pop();
        for(int i=0;i<graf[node].size();i++)
        {
            if(graf[node][i].second=='I') q.push(graf[node][i].first);
        }
        while(!q.empty())
        {
            node=q.front();
            q.pop();
            for(int i=0;i<graf[node].size();i++)
            {
                if(graf[node][i].second=='O') num++;
            }
        }
        cout<<num<<endl;
    }
    else if(n<=1000)
    {
        for(int i=1;i<=n;i++)
        {
            dp[i][i][0]=0;
            dp[i][i][1]=0;
            dp[i][i][2]=0;
            dfsdp(i,i,i);
        }
        int kolko1=0;
        for(int i=1;i<=n;i++)
        {
            for(int j=i+1;j<=n;j++)
            {
                if(dp[i][j][0]==dp[i][j][1] && dp[i][j][1]==dp[i][j][2]) kolko1++;
            }
        }
        cout<<kolko1<<endl;
    }
    else if(niz)
    {
        int kolko=0;
        int ts=0;
        int ti=0;
        int to=0;
        multiset<pair<int,int> > ms;
        ms.insert(make_pair(0,0));
        for(int i=1;i<=n-1;i++)
        {
            //cout<<i<<endl;
            char sta;
            if(graf[i][0].first==i+1) sta=graf[i][0].second;
            else sta=graf[i][1].second;
            if(sta=='I') ti++;
            else  if(sta=='S') ts++;
            else to++;
            //cout<<sta<<endl;
            kolko+=ms.count(make_pair(ts-to,ts-ti));
            ms.insert(make_pair(ts-to,ts-ti));
        }
        cout<<kolko<<endl;
    }
}